// Config
//
// configuration

#include "Inc.h"

// cfg
//
// global configuration

WikiConfig	cfg;

// WikiConfig
//
// clear user list

WikiConfig::WikiConfig()
{
	UserCount = 0;
	UserTable = 0;
}

// ~WikiConfig
//
// delete user list

WikiConfig::~WikiConfig()
{
	delete[] UserTable;
}

// Load*
//
// load into WikiConfig

void WikiConfig::LoadConfig(const char* file)
{
	Headers		Config;

	Config.AddFromFileData(file);

	DefaultPage = Config.Lookup("Default Page", "StartPage");
	RootPage = Config.Lookup("Root Page", "StartPage");
	ContentType = Config.Lookup("Content Type", "text/html; charset=ISO-8859-1");
}

void WikiConfig::LoadInterWiki(const char* file)
{
	InterWiki.DeleteAll();
	InterWiki.AddFromFileData(file);
}

void WikiConfig::LoadLockPages(const char* file)
{
	LockPages.DeleteAll();
	LockPages.AddFromFileData(file);
	LockPages.AddHeader("WikiFooter", "a");
	LockPages.AddHeader("WikiSystemFooter", "a");
}

void WikiConfig::LoadMimeTypes(const char* file)
{
	MimeTypes.DeleteAll();
	MimeTypes.AddFromFileData(file);
}

// GetMimeType
//
// get MIME type for a file extension

const char* WikiConfig::GetMimeType(const char* ext) const
{
	// first lookup - this can override the built-ins if required
	const char*	type = MimeTypes.Lookup(ext);

	// else try the built-in types
	if (!type)
	{
		if (!stricmp(ext, "gif"))									type = "image/gif";
		else if (!stricmp(ext, "jpeg") || !stricmp(ext, "jpg"))		type = "image/jpeg";
		else if (!stricmp(ext, "png"))								type = "image/png";
		else if (!stricmp(ext, "html") || !stricmp(ext, "htm"))		type = "text/html";
		else if (!stricmp(ext, "css"))								type = "text/css";
		else if (!stricmp(ext, "txt"))								type = "text/plain";
		else if (!stricmp(ext, "wik"))								type = "text/plain";
		else														type = "application/unknown";
	}

	return type;
}
