// Config
//
// configuration

class PageSet;
class UserInfo;

class WikiConfig
{
public:
	WikiConfig();
	~WikiConfig();

	// stuff from Config.wkc
	const char*		DefaultPage;
	const char*		RootPage;
	const char*		ContentType;

	// other wkc files
	Headers			InterWiki;
	Headers			LockPages;
	Headers			MimeTypes;

	// users
	Headers			UserList;
	int				UserCount;
	UserInfo*		UserTable;

	// stuff from code
	PageSet*		Pages;
	char*			Pathname;

	void	LoadConfig(const char* file);
	void	LoadInterWiki(const char* file);
	void	LoadLockPages(const char* file);
	void	LoadMimeTypes(const char* file);
	void	LoadUsers(const char* file);

	const char*		GetMimeType(const char* ext) const;
	const UserInfo*	QueryAuth(const char* auth) const;
};

// global configuration
extern WikiConfig	cfg;
