// WikiParser
//
// Text -> HTML generation

class Page;
class PageSet;
class UserInfo;
class Headers;

class WikiParser
{
public:
	void	WikiToHTML(FILE* fd, const char* wiki, CharFmt fmt, const Page* pageref, const UserInfo* user, bool convert);

protected:
	void	CharOut(char ch);
	void	OutputPageLink(const char* pname);

	bool	MatchTree(const char*& lp);
	bool	AcceptLineCommand(const char* lp);
	bool	AcceptPlain(const char*& lp);
	bool	AcceptHeading(const char*& lp);
	bool	AcceptLeftAlignCommand(const char*& lp);
	bool	AcceptSpaceCommand(const char*& lp, int minspaces);

	void	WriteLine(const char* lp);
	char*	ReplacePostfix(const char* lp);
	void	AcceptStrike(const char*& lp);
	void	AcceptQuote(const char*& lp);
	void	AcceptAlpha(const char*& lp);
	void	AcceptSquare(const char*& lp);

	void	AcceptURL(const char* word, const char*& lp);
	bool	AcceptFormCommand(const char* word);
	bool	AcceptDollarCommand(const char* word);
	bool	AcceptEnhancedDollarCommand(const char* word, const char* params);
	void	AcceptFileInsertion(const char* word);

private:
	HTag*			mRoot;
	HTag*			mCT;
	FILE*			mFD;
	const Page*		mPage;
	const UserInfo*	mUser;
	CharFmt			mFmt;
	HCharFmt*		mCharFmt;	// only valid in subfunctions of WriteLine
	bool			mAllowAnchor;
	bool			mAllowTags;
	bool			mConvert;
};
