// WikiUser.h
//
// user handling

// Users.wkc format:
//
// <username>:<password>=<perms>:<homepage>
//
// :=<perms>:<homepage> gives default permissions

class UserInfo
{
public:
	UserInfo();
	~UserInfo();

	void	SetInfo(const char* key, const char* value);
	void	SetDefaultHomepage(const char* hpage);

	const char* GetUsername() const				{ return username ? username : "anonymous user"; }
	const char* GetPassword() const				{ return password ? password : ""; }
	const char* GetPermString() const			{ return perms ? perms : ""; }
	bool		Auth(char action) const;
	const char*	GetHomepage() const				{ return homepage ? homepage : cfg.DefaultPage; }
	bool		IsAnonymous() const				{ return !username; }

private:
	char*	username;
	char*	password;
	char*	perms;
	char*	homepage;
};
