// httprq.h
//
// HTTP_RQ object

#include "headers.h"

class HTTP_RQ
{
public:
	HTTP_RQ();
	~HTTP_RQ();

	void		AttachHeaders(char* hdr);
	void		AttachData(char* data, int len);

	// access
	const char*	GetReq() const		{ return _req; }
	const char*	GetURI() const		{ return _uri; }
	const char*	GetHTTPVer() const	{ return _httpv; }
	const char*	GetAuth() const		{ return _auth; }
	
	const char*	GetHeader(const char* hdrname) const;
	const char*	GetCookie(const char* key) const;

	Headers*	GetParms() const		{ return _parms; }
	Headers*	GetCookieData() const	{ return _cookies; }

private:
	char*		_req;		// req name e.g. GET
	char*		_uri;		// URI name
	char*		_httpv;		// HTTP version
	char*		_auth;		// authorization string

	Headers*	_hdrs;		// headers
	Headers*	_parms;		// data from URI (after ?) and post
	Headers*	_cookies;	// data from cookie

	void		Destroy();
	void		Clear();

	bool		ValidateCommand();
};

const char* StatusLine(int status);
