// os_posix
//
// POSIX OS-specific routines

#ifdef POSIX

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <errno.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <dirent.h>
#include <utime.h>

#include "os.h"

#define DATE_MAX 64

// OS_Init
//
// do any OS-specific initialization

void OS_Init()
{
}

// OS_DetachConsole
//
// detach from console window if possible

void OS_DetachConsole()
{
}

// OS_InitSocketAPI
//
// initialize socket API

bool OS_InitSocketAPI()
{
	return true;
}

// OS_TermSocketAPI
//
// terminate socket API

void OS_TermSocketAPI()
{
}

// OS_GetSocketError
//
// get socket error code

int OS_GetSocketError()
{
	return errno;
}

// OS_MakeTempFilename
//
// make a temp filename using the given tag

void OS_MakeTempFilename(char* buffer, const char* tag)
{
	// TODO: port this WIN32 code
	/*
	char	tp[MAX_PATH];
	GetTempPath(MAX_PATH, tp);

	sprintf(buffer, "%s\\%s_%d.txt", tp, tag, GetCurrentThreadId());
	*/
}

// OS_Yield
//
// yield for a short time

void OS_Yield()
{
}

#endif	// POSIX
