// os_sockets.h
//
// include sockets API

//
// Win32 (winsock)
//

#ifdef WIN32

#include <winsock.h>

#define	SERR_EINTR			WSAEINTR
#define SERR_EWOULDBLOCK	WSAEWOULDBLOCK
#define SERR_EADDRINUSE		WSAEADDRINUSE

typedef int AcceptLengthType;

#endif

//
// POSIX (Berkeley Sockets)
//

#ifdef POSIX

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>

#define SERR_EINTR			EINTR
#define SERR_EWOULDBLOCK	EWOULDBLOCK
#define SERR_EADDRINUSE		EADDRINUSE

#define INVALID_SOCKET		-1
#define SOCKET_ERROR		-1
#define SOCKET				int

#define ioctlsocket			ioctl
#define closesocket			close

typedef unsigned int AcceptLengthType;

#endif

//
// sanos
//

#ifdef SANOS

#include <os.h>

#define SERR_EINTR			EINTR
#define SERR_EWOULDBLOCK	EAGAIN
#define SERR_EADDRINUSE		EADDRINUSE

#define INVALID_SOCKET		-1
#define SOCKET_ERROR		-1
#define SOCKET				int

#define ioctlsocket(S,C,D) ioctl(S, C, D, sizeof(*(D))) 
#define closesocket(S) close(S)

typedef int AcceptLengthType;

#endif
